; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  2010 Coma
; -------------------------------------------------------------------------
; Title         : Coma - Win32 Video Capture Program
; Description   : Video Capture for WebCams and other sources
; Version       : 0.36
; Date          : 17.09.2010
; Company       : Coma
; Author        : Coma
; Homepage      : http://ge2001.dyndns.org:44792
;               : Online 20:00 - 23:00 GMT+2
; Email         : ge2001@yahoo.com
; -------------------------------------------------------------------------
; Assembler     : Microsoft Assembler 6.14.884 / Linker 5.12.8078 / Resource Compiler 5.00.1823.1
;               : ml.exe /c /coff Coma_Win32_VideoCapture.asm
;               : rc.exe /v rsrc.rc
;               : cvtres.exe /machine:ix86 rsrc.res
;               : link.exe /SUBSYSTEM:WINDOWS /OPT:NOREF Coma_Win32_VideoCapture.obj rsrc.res
; -------------------------------------------------------------------------
; Comments      : Freeware, use it on your own risk
;               : Masm32 download: http://movsd.com
;               : Use inc2l.exe avicap32.inc to create avicap32.lib
;               : Use inc2l.exe msvfw32.inc to create msvfw32.lib
;               : Copy the lib file into the required directory
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.586
.MMX
.Model Flat, StdCall
option casemap:none

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
include \masm32\include\shell32.inc
include \masm32\include\shlwapi.inc
include \masm32\include\winmm.inc
include \masm32\include\avicap32.inc
;---
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\shlwapi.lib
includelib \masm32\lib\winmm.lib
includelib \masm32\lib\avicap32.lib
;---
include \masm32\include\windows.inc
include ComaAddon_windows.inc

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP_CallBack             equ [ebp+04]                ; return address
WP_hWnd                 equ [ebp+08]                ; handle window for msg
WP_uMsg                 equ [ebp+12]                ; message number
WP_wParam               equ [ebp+16]                ; extra message info
WP_lParam               equ [ebp+20]                ; extra message info
;---
MAX_PATHEX              equ 1024

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wc                      WNDCLASSEX <>               ; Structures
msg                     MSG <>
icc                     INITCOMMONCONTROLSEX <>
ps                      PAINTSTRUCT <>
nid                     NOTIFYICONDATA <>
rc                      RECT <>
bi                      BROWSEINFO <>
ti                      TOOLINFO <>
tc                      TIMECAPS <>
_st                     SYSTEMTIME <>
_stDTStart              SYSTEMTIME <>
_stDTEnd                SYSTEMTIME <>
_stOut                  SYSTEMTIME <>
cp                      CAPTUREPARMS <>
ft                      FILETIME <>
ftStart                 FILETIME <>
ftEnd                   FILETIME <>
;---
hIcoApplication         dd ?                        ; Handle
hBmpBackground          dd ?
hBrBackground           dd ?
;---
IdTimer                 dd ?
hObjectOld              dd ?
hPen                    dd ?
hFntDefGui              dd ?
hWndCBCaptureDriver     dd ?
hWndCaptureWindow       dd ?
hWndSTLogo              dd ?
hWndBUSource            dd ?
hWndBUDisplay           dd ?
hWndBUFormat            dd ?
hWndBUCompression       dd ?
hWndBUPreview           dd ?
hWndBUStartCapture      dd ?
hWndBUStopCapture       dd ?
hWndBUFrameCapture      dd ?
hWndBUAutoCapture       dd ?
hWndBUAutoCaptureFrame  dd ?
hWndBUAutoCaptureVideo  dd ?
hWndEDInterval          dd ?
hWndUDInterval          dd ?
hWndSB                  dd ?
hWndTT                  dd ?
hWndDTStart             dd ?
hWndDTEnd               dd ?
hSysMenu                dd ?
;---
hInstance               dd ?
ReturnEAX               dd ?
;---
FrameCaptureCounter     dd ?
;---
BufferError             db MAX_PATH     dup (?)     ; Buffer
BufferTargetDir         db MAX_PATHEX   dup (?)
BufferSystemDir         db MAX_PATHEX   dup (?)
BufferDeviceName        db 800 dup (?)
BufferDeviceVersion     db 800 dup (?)
BufferTmp0              db 10000 dup (?)
BufferTmp1              db 10000 dup (?)

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
XorgWindow              dd 0
YorgWindow              dd 0
XmaxWindow              dd 510
YmaxWindow              dd 432
;---
SBParts                 dd 256,332,408,484
;---
flag_Preview            dd 0
flag_AutoCapture        dd 0
flag_AutoCaptureMode    dd 0
;---
szCN                    db "lieruwq4oghqw4oit4jwq09334oidfhtewsrrqghe573",0
szWN                    db "  2010 Coma - Win32 Video Capture",0
;---
szCN_DateTimePick       db "SysDateTimePick32",0
szCN_Statusbar          db "msctls_statusbar32",0
szCN_ToolTips           db "Tooltips_class32",0
szCN_UpDown             db "msctls_updown32",0
szCN_Combobox           db "COMBOBOX",0
szCN_Button             db "BUTTON",0
szCN_Static             db "STATIC",0
szCN_Edit               db "EDIT",0
;---
szSelectTargetFolder    db "Select target folder for captured videos and frames",0
szTargetFolder          db "Target folder for captured files",0
szOpen                  db "open",0
szControl               db "control.exe ",0
szMmsysCpl              db "mmsys.cpl",0
szDTFormat              db "dd'.'MM'.'yyyy' - 'HH':'mm",0
szNull                  db 0
szLogo                  db "Logo",0
szCapture               db "Capture_",0
szDotAvi                db ".avi",0
szDotBmp                db ".bmp",0
szMinus                 db "-",0
szNotConnected          db "Not connected",0
;---
szConnectON             db "Connect: ON",0
szConnectOFF            db "Connect: OFF",0
szPreviewON             db "Preview: ON",0
szPreviewOFF            db "Preview: OFF",0
szCaptureON             db "Capture: ON",0
szCaptureOFF            db "Capture: OFF",0
;---
szVC                    db "VideoCapture",0
szSource                db "Source",0
szDisplay               db "Display",0
szFormat                db "Format",0
szCompression           db "Compression",0
szPreview               db "Preview",0
szStartCapture          db "Start Capture",0
szStopCapture           db "Stop Capture",0
szFrameCapture          db "Capture Frame",0
szAutoCapture           db "Auto Capture",0
szFrame                 db "Frame",0
szVideo                 db "Video",0
szIntervalFormat        db "Interval time for Frame AutoCapture in seconds",0
szStartDateAndStartTime db "Start Date & Start Time",0
szEndDateAndEndTime     db "End Date & End Time",0
szInterval              db "Interval",0
szAudioProperties       db "Audio  Properties",0
szParameterError        db " Date / Time Parameter Error",0
szAbout                 db "About",0
szComaHome              db "Coma Homepage 20:00-23:00 GMT+2",0
szURLComa               db "http://ge2001.dyndns.org:44792",0
szAboutInfo             db "Info",0
szAboutText             db "  2010 Coma - Win32 Video Capture 0.36 - Freeware.  ",13,10,13,10
                        db "To record audio as well :",13,10
                        db "  1. Open Audio Properties.  ",13,10
                        db "  2. Select the volume tab   ",13,10
                        db "  3. In devicevolume select Extended.  ",13,10
                        db "  4. Select Options.  ",13,10
                        db "  5. Select Properties.  ",13,10
                        db "  6. From the Mixer dropdown box select Audio Input.  ",13,10
                        db "  7. Push OK.  ",13,10
                        db "  8. Check the correct audio input source (i.e. Mic).  ",0


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code
align 8
Main:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetModuleHandle,0
mov     wc.hInstance,eax
mov     hInstance,eax
;---
invoke  FindWindow,ADDR szCN,ADDR szWN
cmp     eax,0h
je      RunProgram
mov     ebx,eax
invoke  ShowWindow,ebx,SW_SHOWNORMAL
invoke  SetForegroundWindow,ebx
invoke  ExitProcess,wc.hInstance
mov     eax,msg.wParam
ret
;---
RunProgram:
finit                                           ; init FPU
;---
mov     icc.dwSize,sizeof INITCOMMONCONTROLSEX
mov     icc.dwICC,ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES
invoke  InitCommonControlsEx,ADDR icc
;---
call    SubGetSystemMetrics
;---
invoke  LoadIcon,wc.hInstance,20000
mov     hIcoApplication,eax
mov     wc.hIconSm,eax
mov     wc.hIcon,eax
invoke  LoadCursor,0,IDC_ARROW
mov     wc.hCursor,eax
invoke  LoadBitmap,wc.hInstance,20001
mov     hBmpBackground,eax
invoke  CreatePatternBrush,hBmpBackground
mov     hBrBackground,eax
mov     wc.hbrBackground,eax
mov     wc.cbSize,sizeof WNDCLASSEX
mov     wc.style,CS_HREDRAW or CS_VREDRAW
mov     wc.lpfnWndProc,OFFSET WP
mov     wc.cbClsExtra,0
mov     wc.cbWndExtra,0
mov     wc.lpszMenuName,0
mov     wc.lpszClassName,OFFSET szCN
invoke  RegisterClassEx,ADDR wc
;---
invoke  CreateWindowEx,0,ADDR szCN,ADDR szWN,WS_OVERLAPPED or WS_CAPTION or WS_CLIPCHILDREN or WS_SYSMENU or WS_MINIMIZEBOX,XorgWindow,YorgWindow,XmaxWindow,YmaxWindow,0,0,wc.hInstance,0
mov     msg.hwnd,eax
invoke  ShowWindow,msg.hwnd,SW_SHOWNORMAL
invoke  UpdateWindow,msg.hwnd



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MessageLoop:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetMessage,ADDR msg,0,0,0
cmp     eax,0h
je      TerminateProgram
invoke  TranslateMessage,ADDR msg
invoke  DispatchMessage,ADDR msg
jmp     MessageLoop
; -------------------------------------------------------------------------
TerminateProgram:
invoke  DeleteObject,hIcoApplication
invoke  DeleteObject,hBmpBackground
invoke  DeleteObject,hBrBackground
invoke  ExitProcess,wc.hInstance
mov     eax,msg.wParam
ret



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TP:                                             ; Timer Procedure
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push    ebp
mov     ebp,esp
pushad
;---
cmp     flag_AutoCapture,0
je      TP_Return
cmp     flag_AutoCapture,1
je      TP_AviStartCapture
cmp     flag_AutoCapture,2
je      TP_AviStopCapture
cmp     flag_AutoCapture,3
je      TP_FrameStartCapture
cmp     flag_AutoCapture,4
je      TP_FrameStopCapture
jmp     TP_Return
;---
TP_AviStartCapture:
invoke  SendMessage,hWndCBCaptureDriver,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      TP_Return
cmp     eax,0
je      TP_Return
invoke  GetLocalTime,ADDR _st
invoke  TzSpecificLocalTimeToSystemTime,0,ADDR _st,ADDR _stOut
invoke  SystemTimeToFileTime,ADDR _stOut,ADDR ft
invoke  CompareFileTime,ADDR ft,ADDR ftStart
cmp     eax,-1
je      TP_Return
call    SubCapAvi
mov     flag_AutoCapture,2
jmp     TP_Return
;---
TP_AviStopCapture:
invoke  GetLocalTime,ADDR _st
invoke  TzSpecificLocalTimeToSystemTime,0,ADDR _st,ADDR _stOut
invoke  SystemTimeToFileTime,ADDR _stOut,ADDR ft
invoke  CompareFileTime,ADDR ft,ADDR ftEnd
cmp     eax,-1
je      TP_Return
invoke  SendMessage,hWndCaptureWindow,WM_CAP_STOP,0,0
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureOFF
call    SubAutoCaptureOFFSetControls
mov     flag_AutoCapture,0
jmp     TP_Return
;---
TP_FrameStartCapture:
invoke  GetLocalTime,ADDR _st
invoke  TzSpecificLocalTimeToSystemTime,0,ADDR _st,ADDR _stOut
invoke  SystemTimeToFileTime,ADDR _stOut,ADDR ft
invoke  CompareFileTime,ADDR ft,ADDR ftStart
cmp     eax,-1
je      TP_Return
mov     flag_AutoCapture,4
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureON
call    SubCapFrame
jmp     TP_Return
;---
TP_FrameStopCapture:
invoke  SendMessage,hWndUDInterval,UDM_GETPOS,0,0
inc     FrameCaptureCounter
cmp     eax,FrameCaptureCounter
jne     TP_Return
call    SubCapFrame
mov     FrameCaptureCounter,0
invoke  GetLocalTime,ADDR _st
invoke  TzSpecificLocalTimeToSystemTime,0,ADDR _st,ADDR _stOut
invoke  SystemTimeToFileTime,ADDR _stOut,ADDR ft
invoke  CompareFileTime,ADDR ft,ADDR ftEnd
cmp     eax,-1
je      TP_Return
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureOFF
call    SubAutoCaptureOFFSetControls
mov     flag_AutoCapture,0
jmp     TP_Return
; -------------------------------------------------------------------------
TP_Return:
; -------------------------------------------------------------------------
popad
mov     esp,ebp
pop     ebp
ret     14h



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP:                                             ; Window Procedure
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push    ebp
mov     ebp,esp
pushad
mov     eax,WP_uMsg
; -------------------------------------------------------------------------
WP_WM_CREATE:
cmp     eax,WM_CREATE
jne     WP_WM_DESTROY
; -------------------------------------------------------------------------
invoke  GetSystemDirectory,ADDR BufferSystemDir,MAX_PATHEX
invoke  PathAddBackslash,ADDR BufferSystemDir
invoke  GetCurrentDirectory,MAX_PATHEX,ADDR BufferTargetDir
invoke  PathAddBackslash,ADDR BufferTargetDir
invoke  GetStockObject,DEFAULT_GUI_FONT
mov     hFntDefGui,eax
invoke  SendMessage,WP_hWnd,WM_SETFONT,hFntDefGui,1
call    SubCreateSysMenu
call    Sub_WMCreate
invoke  timeGetDevCaps,ADDR tc,sizeof TIMECAPS
invoke  timeSetEvent,1000,tc.wPeriodMin,ADDR TP,0,TIME_PERIODIC
mov     IdTimer,eax
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DESTROY:
cmp     eax,WM_DESTROY
jne     WP_WM_SYSCOMMAND
; -------------------------------------------------------------------------
invoke  PostQuitMessage,0
popad
xor     eax,eax
mov     esp,ebp
pop     ebp
ret     10h

; -------------------------------------------------------------------------
WP_WM_SYSCOMMAND:
cmp     eax,WM_SYSCOMMAND
jne     WP_WM_SIZE
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,SC_CLOSE
jne     WP_WM_SYSCOMMAND_Target
invoke  AnimateWindow,WP_hWnd,500,AW_HIDE or AW_BLEND
call    SubCleanSystem
jmp     WP_Return
;---
WP_WM_SYSCOMMAND_Target:
cmp     ax,1050
jne     WP_WM_SYSCOMMAND_Audio
call    SubBrowseForFolder
jmp     WP_Return
;---
WP_WM_SYSCOMMAND_Audio:
cmp     ax,1051
jne     WP_WM_SYSCOMMAND_Coma
invoke  ShellExecute,WP_hWnd,ADDR szOpen,ADDR szControl,ADDR szMmsysCpl,ADDR BufferSystemDir,SW_SHOWNORMAL
cmp     eax,32
ja      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_SYSCOMMAND_Coma:
cmp     ax,1052
jne     WP_WM_SYSCOMMAND_About
invoke  ShellExecute,WP_hWnd,0,ADDR szURLComa,0,0,0
cmp     eax,32
ja      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_SYSCOMMAND_About:
cmp     ax,1053
jne     WP_Return
invoke  MessageBox,WP_hWnd,ADDR szAboutText,ADDR szAboutInfo,MB_OK or MB_ICONINFORMATION or MB_SYSTEMMODAL or MB_TOPMOST
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_SIZE:
cmp     eax,WM_SIZE
jne     WP_WM_PAINT
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     ax,SIZE_MINIMIZED
jne     WP_Return
mov     nid.cbSize,sizeof nid
mov     eax,WP_hWnd
mov     nid.hwnd,eax
mov     nid.uID,0
mov     nid.uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
mov     nid.uCallbackMessage,1280
mov     eax,hIcoApplication
mov     nid.hIcon,eax
invoke  lstrcpy,ADDR nid.szTip,ADDR szVC
invoke  ShowWindow,WP_hWnd,SW_HIDE
invoke  Shell_NotifyIcon,NIM_ADD,ADDR nid
jmp     WP_Return0

; -------------------------------------------------------------------------
WP_WM_PAINT:
cmp     eax,WM_PAINT
jne     WP_WM_NOTIFY
; -------------------------------------------------------------------------
invoke  BeginPaint,WP_hWnd,ADDR ps
mov     ebx,eax
invoke  CreatePen,PS_SOLID,1,00C8C8C8h
mov     hPen,eax
invoke  SelectObject,ebx,hPen
mov     hObjectOld,eax
invoke  MoveToEx,ebx,4,299,0
invoke  LineTo,ebx,500,299
invoke  MoveToEx,ebx,4,349,0
invoke  LineTo,ebx,500,349
invoke  DeleteObject,hPen
invoke  SelectObject,ebx,hObjectOld
invoke  SelectObject,ebx,hFntDefGui
mov     hObjectOld,eax
invoke  SetTextColor,ebx,00FFFFFFh
invoke  SetBkMode,ebx,TRANSPARENT
invoke  TextOut,ebx,21,310,ADDR szFrame,5
invoke  TextOut,ebx,21,325,ADDR szVideo,5
invoke  TextOut,ebx,59,302,ADDR szStartDateAndStartTime,23
invoke  TextOut,ebx,184,302,ADDR szEndDateAndEndTime,19
invoke  TextOut,ebx,304,302,ADDR szInterval,8
invoke  lstrlen,ADDR BufferTargetDir
invoke  TextOut,ebx,4,356,ADDR BufferTargetDir,eax
invoke  DeleteObject,hFntDefGui
invoke  SelectObject,ebx,hObjectOld
invoke  EndPaint,WP_hWnd,ADDR ps
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NOTIFY:
cmp     eax,WM_NOTIFY
jne     WP_WM_DISPLAYCHANGE
; -------------------------------------------------------------------------
mov     ebx,WP_lParam 
;---
WP_WM_NOTIFY_DTStart:
mov     eax,[ebx+0]
cmp     eax,hWndDTStart
jne     WP_WM_NOTIFY_DTEnd
;---
mov     eax,[ebx+8]
cmp     eax,DTN_DATETIMECHANGE
jne     WP_Return
;---
mov     eax,[ebx+12]
cmp     eax,GDT_VALID
jne     WP_Return
invoke  SendMessage,hWndDTStart,DTM_GETSYSTEMTIME,0,ADDR _stDTStart
mov     ax,0
mov     _stDTStart.wSecond,ax
mov     _stDTStart.wMilliseconds,ax
jmp     WP_Return
;---
WP_WM_NOTIFY_DTEnd:
mov     eax,[ebx+0]
cmp     eax,hWndDTEnd
jne     WP_Return
mov     eax,[ebx+8]
cmp     eax,DTN_DATETIMECHANGE
jne     WP_Return
;---
mov     eax,[ebx+12]
cmp     eax,GDT_VALID
jne     WP_Return
invoke  SendMessage,hWndDTEnd,DTM_GETSYSTEMTIME,0,ADDR _stDTEnd
mov     ax,0
mov     _stDTEnd.wSecond,ax
mov     _stDTEnd.wMilliseconds,ax
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DISPLAYCHANGE:
cmp     eax,WM_DISPLAYCHANGE
jne     WP_WM_NCMOUSEMOVE
; -------------------------------------------------------------------------
invoke  InvalidateRect,WP_hWnd,0,0
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NCMOUSEMOVE:
cmp     eax,WM_NCMOUSEMOVE
jne     WP_WM_USER
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_USER:
cmp     eax,1280
jne     WP_WM_COMMAND
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     ax,0
jne     WP_Return  
mov     eax,WP_lParam
cmp     eax,WM_LBUTTONDOWN
jne     WP_Return
invoke  SetForegroundWindow,WP_hWnd
invoke  Shell_NotifyIcon,NIM_DELETE,ADDR nid
invoke  ShowWindow,WP_hWnd,SW_RESTORE
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_COMMAND:
cmp     eax,WM_COMMAND
jne     WP_WM_TIMER
; -------------------------------------------------------------------------
mov     eax,WP_wParam                           ; control or menu ID in ax
; -------------------------------------------------------------------------
WP_WM_COMMAND_2000:
cmp     ax,2000
jne     WP_WM_COMMAND_2300
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
mov     eax,WP_wParam
shr     eax,16
cmp     eax,CBN_SELCHANGE
jne     WP_Return
invoke  SendMessage,hWndCBCaptureDriver,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      WP_Return
cmp     eax,0
jne     WP_WM_COMMAND_2000_Connect
WP_WM_COMMAND_2000_Disconnect:
mov     flag_AutoCapture,0
call    SubCapDriverDisconnect
call    SubDisableControls
invoke  EnableWindow,hWndBUAutoCapture,0
jmp     WP_Return
WP_WM_COMMAND_2000_Connect:
call    SubCapDriverConnect
call    SubEnableControls
cmp     flag_AutoCaptureMode,0
je      WP_WM_COMMAND_2000_Connect_AutoCaptureFrame
cmp     flag_AutoCaptureMode,1
je      WP_WM_COMMAND_2000_Connect_AutoCaptureAvi
jmp     WP_Return
WP_WM_COMMAND_2000_Connect_AutoCaptureFrame:
call    SubFrameCaptureSetControls
jmp     WP_Return
WP_WM_COMMAND_2000_Connect_AutoCaptureAvi:
call    SubAviCaptureSetControls
jmp     WP_Return
;---
WP_WM_COMMAND_2300:
cmp     ax,2300
jne     WP_WM_COMMAND_2400
invoke  ShellExecute,WP_hWnd,0,ADDR szURLComa,0,0,0
cmp     eax,32
ja      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_COMMAND_2400:
cmp     ax,2400
jne     WP_WM_COMMAND_2401
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
invoke  SendMessage,hWndCaptureWindow,WM_CAP_DLG_VIDEOSOURCE,0,0
cmp     eax,1
je      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_COMMAND_2401:
cmp     ax,2401
jne     WP_WM_COMMAND_2402
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
invoke  SendMessage,hWndCaptureWindow,WM_CAP_DLG_VIDEODISPLAY,0,0
cmp     eax,1
je      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_COMMAND_2402:
cmp     ax,2402
jne     WP_WM_COMMAND_2403
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
invoke  SendMessage,hWndCaptureWindow,WM_CAP_DLG_VIDEOFORMAT,0,0
cmp     eax,1
je      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_COMMAND_2403:
cmp     ax,2403
jne     WP_WM_COMMAND_2410
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
invoke  SendMessage,hWndCaptureWindow,WM_CAP_DLG_VIDEOCOMPRESSION,0,0
cmp     eax,1
je      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_COMMAND_2410:
cmp     ax,2410
jne     WP_WM_COMMAND_2420
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
xor     flag_Preview,1
invoke  SendMessage,hWndCaptureWindow,WM_CAP_SET_PREVIEW,flag_Preview,0
cmp     flag_Preview,0
jne     WP_WM_COMMAND_2410_PreviewON
WP_WM_COMMAND_2410_PreviewOFF:
invoke  SendMessage,hWndSB,SB_SETTEXT,2,ADDR szPreviewOFF
jmp     WP_Return
WP_WM_COMMAND_2410_PreviewON:
invoke  SendMessage,hWndSB,SB_SETTEXT,2,ADDR szPreviewON
jmp     WP_Return
;---
WP_WM_COMMAND_2420:
cmp     ax,2420
jne     WP_WM_COMMAND_2430
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
call    SubDisableControls1
invoke  EnableWindow,hWndCBCaptureDriver,0
invoke  EnableMenuItem,hSysMenu,1050,MF_GRAYED
call    SubCapAvi
jmp     WP_Return
;---
WP_WM_COMMAND_2430:
cmp     ax,2430
jne     WP_WM_COMMAND_2440
invoke  SendMessage,hWndCaptureWindow,WM_CAP_STOP,0,0
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureOFF
invoke  EnableWindow,hWndCBCaptureDriver,1
invoke  EnableMenuItem,hSysMenu,1050,MF_ENABLED
call    SubEnableControls
jmp     WP_Return
;---
WP_WM_COMMAND_2440:
cmp     ax,2440
jne     WP_WM_COMMAND_2450
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
call    SubCapFrame
jmp     WP_Return
;---
WP_WM_COMMAND_2450:
cmp     ax,2450
jne     WP_WM_COMMAND_2451
mov     flag_AutoCaptureMode,0
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
call    SubFrameCaptureSetControls
jmp     WP_Return
;---
WP_WM_COMMAND_2451:
cmp     ax,2451
jne     WP_WM_COMMAND_2490
mov     flag_AutoCaptureMode,1
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
call    SubAviCaptureSetControls
jmp     WP_Return
;---
WP_WM_COMMAND_2490:
cmp     ax,2490
jne     WP_Return
call    SubLocalStartTime
call    SubLocalEndTime
invoke  CompareFileTime,ADDR ftStart,ADDR ftEnd
cmp     eax,0
je      WP_WM_COMMAND_2490_ParameterError
cmp     eax,+1
je      WP_WM_COMMAND_2490_ParameterError
invoke  GetLocalTime,ADDR _st
invoke  TzSpecificLocalTimeToSystemTime,0,ADDR _st,ADDR _stOut
invoke  SystemTimeToFileTime,ADDR _stOut,ADDR ft
invoke  CompareFileTime,ADDR ft,ADDR ftEnd
cmp     eax,+1
je      WP_WM_COMMAND_2490_ParameterError
;---
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szWN
cmp     flag_AutoCaptureMode,0
je      WP_WM_COMMAND_2490_AutoFrameCapture
cmp     flag_AutoCaptureMode,1
je      WP_WM_COMMAND_2490_AutoAviCapture
jmp     WP_Return
WP_WM_COMMAND_2490_AutoFrameCapture:
cmp     flag_AutoCapture,0
je      WP_WM_COMMAND_2490_AutoFrameCaptureON
WP_WM_COMMAND_2490_AutoFrameCaptureOFF:
mov     flag_AutoCapture,0
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureOFF
call    SubAutoCaptureOFFSetControls
jmp     WP_Return
WP_WM_COMMAND_2490_AutoFrameCaptureON:
invoke  SendMessage,hWndUDInterval,UDM_GETPOS,0,0
mov     ebx,eax
shr     ebx,16
cmp     ebx,0
je      WP_WM_COMMAND_2490_AutoFrameCaptureONGo
call    SubGetLastError
jmp     WP_Return
WP_WM_COMMAND_2490_AutoFrameCaptureONGo:
mov     FrameCaptureCounter,0
call    SubDisableControls
invoke  EnableWindow,hWndCBCaptureDriver,0
invoke  EnableMenuItem,hSysMenu,1050,MF_GRAYED
mov     flag_AutoCapture,3
jmp     WP_Return
WP_WM_COMMAND_2490_AutoAviCapture:
cmp     flag_AutoCapture,0
je      WP_WM_COMMAND_2490_AutoAviCaptureON
WP_WM_COMMAND_2490_AutoAviCaptureOFF:
mov     flag_AutoCapture,0
invoke  SendMessage,hWndCaptureWindow,WM_CAP_STOP,0,0
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureOFF
call    SubAutoCaptureOFFSetControls
jmp     WP_Return
WP_WM_COMMAND_2490_AutoAviCaptureON:
call    SubDisableControls
invoke  EnableWindow,hWndCBCaptureDriver,0
invoke  EnableMenuItem,hSysMenu,1050,MF_GRAYED
mov     flag_AutoCapture,1
jmp     WP_Return
WP_WM_COMMAND_2490_ParameterError:
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR szParameterError
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_TIMER:
cmp     eax,WM_TIMER
jne     WP_WM_CTLCOLORBTN
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORBTN:
cmp     eax,WM_CTLCOLORBTN
jne     WP_WM_CTLCOLORSTATIC
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORSTATIC:
cmp     eax,WM_CTLCOLORSTATIC
jne     WP_WM_CTLCOLOREDIT
; -------------------------------------------------------------------------
mov     eax,WP_lParam
cmp     eax,hWndBUAutoCaptureFrame
je      WP_WM_CTLCOLORSTATIC_Go
cmp     eax,hWndBUAutoCaptureVideo
je      WP_WM_CTLCOLORSTATIC_Go
jmp     WP_Return
WP_WM_CTLCOLORSTATIC_Go:
invoke  SetBkMode,WP_wParam,TRANSPARENT
invoke  SetBkColor,WP_wParam,0
invoke  SetTextColor,WP_wParam,0000D6FFh
mov     eax,hBrBackground
mov     ReturnEAX,eax
jmp     WP_ReturnEAX


; -------------------------------------------------------------------------
WP_WM_CTLCOLOREDIT:
cmp     eax,WM_CTLCOLOREDIT
jne     WP_WM_CTLCOLORLISTBOX
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORLISTBOX:
cmp     eax,WM_CTLCOLORLISTBOX
jne     WP_WM_WINDOWPOSCHANGING
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_WINDOWPOSCHANGING:
cmp     eax,WM_WINDOWPOSCHANGING
jne     WP_WM_DRAWITEM
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DRAWITEM:
cmp     eax,WM_DRAWITEM
jne     WP_WM_PARENTNOTIFY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_PARENTNOTIFY:
cmp     eax,WM_PARENTNOTIFY
jne     WP_WM_RBUTTONDOWN
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_RBUTTONDOWN:
cmp     eax,WM_RBUTTONDOWN
jne     WP_WM_MOUSEMOVE
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_MOUSEMOVE:
cmp     eax,WM_MOUSEMOVE
jne     WP_WM_CONTEXTMENU
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CONTEXTMENU:
cmp     eax,WM_CONTEXTMENU
jne     WP_WM_POWERBROADCAST
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_POWERBROADCAST:
cmp     eax,WM_POWERBROADCAST
jne     WP_WM_ERASEBKGND
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,PBT_APMRESUMESUSPEND
jne     WP_Return
mov     eax,WP_lParam
cmp     eax,PBTF_APMRESUMEFROMFAILURE
je      WP_Return
invoke  RedrawWindow,WP_hWnd,0,0,RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_ERASEBKGND:
cmp     eax,WM_ERASEBKGND
jne     WP_WM_ACTIVATE
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_ACTIVATE:
cmp     eax,WM_ACTIVATE
jne     WP_WM_HSCROLL
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_HSCROLL:
cmp     eax,WM_HSCROLL
jne     WP_WM_VSCROLL
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_VSCROLL:
cmp     eax,WM_VSCROLL
jne     WP_WM_SYNCPAINT
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_SYNCPAINT:
cmp     eax,WM_SYNCPAINT
jne     WP_Return
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_Return:
; -------------------------------------------------------------------------
popad
invoke  DefWindowProc,WP_hWnd,WP_uMsg,WP_wParam,WP_lParam
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return0:
; -------------------------------------------------------------------------
popad
mov     eax,0
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return1:
; -------------------------------------------------------------------------
popad
mov     eax,1
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_ReturnEAX:
; -------------------------------------------------------------------------
popad
mov     eax,ReturnEAX
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; SubRoutines
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SubGetSystemMetrics:
invoke  GetSystemMetrics,SM_CXSCREEN
cmp     eax,XmaxWindow
jbe     SubGetSystemMetricsRet
shr     eax,1
mov     ebx,XmaxWindow
shr     ebx,1
sub     eax,ebx
mov     XorgWindow,eax
invoke  GetSystemMetrics,SM_CYSCREEN
cmp     eax,YmaxWindow
jbe     SubGetSystemMetricsRet
shr     eax,1
mov     ebx,YmaxWindow
shr     ebx,1
sub     eax,ebx
mov     YorgWindow,eax
;---
SubGetSystemMetricsRet:
ret
; -------------------------------------------------------------------------
Sub_WMCreate:
invoke  CreateWindowEx,0,ADDR szCN_Combobox,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER or WS_VSCROLL or CBS_NOINTEGRALHEIGHT or CBS_DROPDOWNLIST,24,10,320,400,WP_hWnd,2000,wc.hInstance,0
mov     hWndCBCaptureDriver,eax
invoke  SendMessage,hWndCBCaptureDriver,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndCBCaptureDriver,CB_ADDSTRING,0,ADDR szNotConnected
;---
invoke  capCreateCaptureWindow,ADDR szVC,WS_CHILD or WS_VISIBLE,24,48,320,240,WP_hWnd,2100
mov     hWndCaptureWindow,eax
;---
invoke  CreateWindowEx,0,ADDR szCN_Statusbar,ADDR szWN,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SBARS_SIZEGRIP,0,512,720,24,WP_hWnd,2200,wc.hInstance,0
mov     hWndSB,eax
invoke  SendMessage,hWndSB,WM_SETFONT,hFntDefGui,1
invoke  SendMessage,hWndSB,SB_SETPARTS,4,ADDR SBParts
invoke  SendMessage,hWndSB,SB_SETTEXT,1,ADDR szConnectOFF
invoke  SendMessage,hWndSB,SB_SETTEXT,2,ADDR szPreviewOFF
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureOFF
;---
invoke  CreateWindowEx,0,ADDR szCN_Static,ADDR szLogo,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER or SS_BITMAP or SS_NOTIFY,359,9,0,0,WP_hWnd,2300,wc.hInstance,0
mov     hWndSTLogo,eax
;---
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szSource,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,47,120,24,WP_hWnd,2400,wc.hInstance,0
mov     hWndBUSource,eax
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szDisplay,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,78,120,24,WP_hWnd,2401,wc.hInstance,0
mov     hWndBUDisplay,eax
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szFormat,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,109,120,24,WP_hWnd,2402,wc.hInstance,0
mov     hWndBUFormat,eax
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szCompression,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,140,120,24,WP_hWnd,2403,wc.hInstance,0
mov     hWndBUCompression,eax
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szPreview,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,171,120,24,WP_hWnd,2410,wc.hInstance,0
mov     hWndBUPreview,eax
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szStartCapture,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,202,120,24,WP_hWnd,2420,wc.hInstance,0
mov     hWndBUStartCapture,eax
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szStopCapture,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,233,120,24,WP_hWnd,2430,wc.hInstance,0
mov     hWndBUStopCapture,eax
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szFrameCapture,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,264,120,24,WP_hWnd,2440,wc.hInstance,0
mov     hWndBUFrameCapture,eax
;---
invoke  CreateWindowEx,0,ADDR szCN_Button,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or WS_GROUP or BS_AUTORADIOBUTTON,5,310,12,15,WP_hWnd,2450,wc.hInstance,0
mov     hWndBUAutoCaptureFrame,eax
invoke  SendMessage,hWndBUAutoCaptureFrame,BM_SETCHECK,BST_CHECKED,0
invoke  CreateWindowEx,0,ADDR szCN_Button,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_AUTORADIOBUTTON,5,325,12,15,WP_hWnd,2451,wc.hInstance,0
mov     hWndBUAutoCaptureVideo,eax
;---
invoke  SendMessage,hWndDTEnd,DTM_SETFORMAT,0,ADDR szDTFormat
invoke  CreateWindowEx,0,ADDR szCN_Edit,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or WS_BORDER or ES_NUMBER or ES_CENTER,300,318,72,17,WP_hWnd,2460,wc.hInstance,0
mov     hWndEDInterval,eax
invoke  SendMessage,hWndEDInterval,WM_SETFONT,hFntDefGui,1
invoke  SendMessage,hWndEDInterval,EM_LIMITTEXT,5,0
invoke  CreateUpDownControl,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or UDS_AUTOBUDDY or UDS_SETBUDDYINT or UDS_WRAP or UDS_ARROWKEYS or UDS_NOTHOUSANDS or UDS_ALIGNRIGHT or UDS_HOTTRACK,0,0,20,17,WP_hWnd,2461,wc.hInstance,hWndEDInterval,32766,1,5
mov     hWndUDInterval,eax
;---
invoke  CreateWindowEx,0,ADDR szCN_DateTimePick,0,WS_CHILD or WS_VISIBLE or WS_DISABLED or DTS_SHORTDATECENTURYFORMAT or DTS_TIMEFORMAT,55,316,119,21,WP_hWnd,2470,wc.hInstance,0
mov     hWndDTStart,eax
invoke  SendMessage,hWndDTStart,DTM_SETFORMAT,0,ADDR szDTFormat
invoke  SendMessage,hWndDTStart,DTM_GETSYSTEMTIME,0,ADDR _stDTStart
mov     ax,0
mov     _stDTStart.wSecond,ax
mov     _stDTStart.wMilliseconds,ax
invoke  CreateWindowEx,0,ADDR szCN_DateTimePick,0,WS_CHILD or WS_VISIBLE or WS_DISABLED or DTS_SHORTDATECENTURYFORMAT or DTS_TIMEFORMAT,176,316,119,21,WP_hWnd,2480,wc.hInstance,0
mov     hWndDTEnd,eax
invoke  SendMessage,hWndDTEnd,DTM_SETFORMAT,0,ADDR szDTFormat
invoke  SendMessage,hWndDTEnd,DTM_GETSYSTEMTIME,0,ADDR _stDTEnd
mov     ax,0
mov     _stDTEnd.wSecond,ax
mov     _stDTEnd.wMilliseconds,ax
;---
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szAutoCapture,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_PUSHBUTTON,368,314,120,24,WP_hWnd,2490,wc.hInstance,0
mov     hWndBUAutoCapture,eax
;---
invoke  CreateWindowEx,WS_EX_TOPMOST,ADDR szCN_ToolTips,0,WS_VISIBLE or WS_POPUP or TTS_NOPREFIX or TTS_ALWAYSTIP or TTS_BALLOON,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,wc.hInstance,0
mov     hWndTT,eax
invoke  SetWindowPos,hWndTT,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE
invoke  SendMessage,hWndTT,TTM_SETTITLE,1,ADDR szComaHome
mov     ti.cbSize,sizeof ti
mov     eax,WP_hWnd
mov     ti.hWnd,eax 
mov     ti.uFlags,TTF_SUBCLASS or TTF_IDISHWND
mov     eax,hWndSTLogo
mov     ti.uId,eax
mov     ti.lpszText,OFFSET szURLComa
invoke  SendMessage,hWndTT,TTM_ADDTOOL,0,ADDR ti
;---
mov     eax,hWndEDInterval
mov     ti.uId,eax
mov     ti.lpszText,OFFSET szIntervalFormat
invoke  SendMessage,hWndTT,TTM_ADDTOOL,0,ADDR ti
;---
mov     eax,WP_hWnd                                 ; Bugfix starts here, Microsoft doesn't solve it since years !
mov     ti.uId,eax
mov     ti.lpszText,OFFSET szNull
invoke  SendMessage,hWndTT,TTM_ADDTOOL,0,ADDR ti    ; Bugfix ends here
invoke  SendMessage,hWndTT,TTM_ACTIVATE,1,ADDR ti
;---
mov     ebx,0
mov     esi,OFFSET BufferDeviceName
mov     edi,OFFSET BufferDeviceVersion
Sub_EnumerateCaptureDriverLoop:
invoke  capGetDriverDescription,bl,esi,80,edi,80
cmp     eax,0
je      Sub_EnumerateCaptureDriverSkip
invoke  SendMessage,hWndCBCaptureDriver,CB_ADDSTRING,0,esi
Sub_EnumerateCaptureDriverSkip:
add     esi,80
add     edi,80
inc     ebx
cmp     ebx,10
jne     Sub_EnumerateCaptureDriverLoop
invoke  SendMessage,hWndCBCaptureDriver,CB_SETCURSEL,0,0
;---
ret

; -------------------------------------------------------------------------
SubBrowseForFolder:
mov     eax,WP_hWnd
mov     bi.hwndOwner,eax
mov     bi.pidlRoot,CSIDL_DESKTOP
mov     bi.pszDisplayName,OFFSET BufferTmp0
mov     bi.lpszTitle,OFFSET szSelectTargetFolder
mov     bi.ulFlags,BIF_BROWSEINCLUDEURLS or BIF_RETURNONLYFSDIRS
invoke  SHBrowseForFolder,ADDR bi
cmp     eax,0h
je      SubGetLastError
invoke  SHGetPathFromIDList,eax,ADDR BufferTmp1
cmp     eax,1
jne     SubGetLastError
invoke  lstrcpy,ADDR BufferTargetDir,ADDR BufferTmp1
invoke  PathAddBackslash,ADDR BufferTargetDir
invoke  InvalidateRect,WP_hWnd,0,1
ret

; -------------------------------------------------------------------------
SubCapDriverConnect:
dec     eax
invoke  SendMessage,hWndCaptureWindow,WM_CAP_DRIVER_CONNECT,eax,0
cmp     eax,0
je      SubGetLastError
invoke  SendMessage,hWndSB,SB_SETTEXT,1,ADDR szConnectON
invoke  SendMessage,hWndCaptureWindow,WM_CAP_SET_SCALE,1,0
invoke  SendMessage,hWndCaptureWindow,WM_CAP_SET_OVERLAY,1,0
invoke  SendMessage,hWndCaptureWindow,WM_CAP_SET_PREVIEWRATE,50,0
invoke  SendMessage,hWndCaptureWindow,WM_CAP_GET_SEQUENCE_SETUP,sizeof cp,ADDR cp
cmp     eax,1
jne     SubGetLastError
mov     cp.dwRequestMicroSecPerFrame,20000
;mov     cp.wPercentDropForError,0
mov     cp.vKeyAbort,0
mov     cp.fYield,1
mov     cp.fAbortLeftMouse,0
mov     cp.fAbortRightMouse,0
mov     cp.AVStreamMaster,AVSTREAMMASTER_AUDIO
invoke  SendMessage,hWndCaptureWindow,WM_CAP_SET_SEQUENCE_SETUP,sizeof cp,ADDR cp
cmp     eax,1
jne     SubGetLastError
ret

; -------------------------------------------------------------------------
SubCapDriverDisconnect:
invoke  SendMessage,hWndCaptureWindow,WM_CAP_DRIVER_DISCONNECT,0,0
cmp     eax,0
je      SubGetLastError
invoke  SendMessage,hWndCaptureWindow,WM_CAP_STOP,0,0
invoke  SendMessage,hWndSB,SB_SETTEXT,1,ADDR szConnectOFF
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureOFF
ret

; -------------------------------------------------------------------------
SubCapFrame:
invoke  SendMessage,hWndCaptureWindow,WM_CAP_GRAB_FRAME_NOSTOP,0,0
invoke  lstrcpy,ADDR BufferTmp0,ADDR BufferTargetDir
invoke  lstrcat,ADDR BufferTmp0,ADDR szCapture
call    SubFileTimestamp
invoke  lstrcat,ADDR BufferTmp0,ADDR szDotBmp
invoke  SendMessage,hWndCaptureWindow,WM_CAP_FILE_SAVEDIB,0,ADDR BufferTmp0
ret

; -------------------------------------------------------------------------
SubCapAvi:
invoke  lstrcpy,ADDR BufferTmp0,ADDR BufferTargetDir
invoke  lstrcat,ADDR BufferTmp0,ADDR szCapture
call    SubFileTimestamp
invoke  lstrcat,ADDR BufferTmp0,ADDR szDotAvi
invoke  SendMessage,hWndCaptureWindow,WM_CAP_FILE_SET_CAPTURE_FILE,0,ADDR BufferTmp0
invoke  SendMessage,hWndCaptureWindow,WM_CAP_SEQUENCE,0,0
invoke  SendMessage,hWndSB,SB_SETTEXT,3,ADDR szCaptureON
ret

; -------------------------------------------------------------------------
SubFileTimestamp:
invoke  RtlZeroMemory,ADDR BufferTmp1,10000
invoke  GetLocalTime,ADDR _st
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wDay
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferTmp0,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMonth
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferTmp0,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wYear
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferTmp0,ADDR BufferTmp1+6
invoke  lstrcat,ADDR BufferTmp0,ADDR szMinus
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wHour
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferTmp0,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wMinute
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferTmp0,ADDR BufferTmp1+8
mov     eax,0
mov     edi,OFFSET BufferTmp1
mov     ax,_st.wSecond
call    SubHexDDtoStringDec
invoke  lstrcat,ADDR BufferTmp0,ADDR BufferTmp1+8
ret

; -------------------------------------------------------------------------
SubLocalStartTime:
invoke  TzSpecificLocalTimeToSystemTime,0,ADDR _stDTStart,ADDR _stOut
cmp     eax,0
je      SubGetLastError
invoke  SystemTimeToFileTime,ADDR _stOut,ADDR ftStart
cmp     eax,0
je      SubGetLastError
ret

; -------------------------------------------------------------------------
SubLocalEndTime:
invoke  TzSpecificLocalTimeToSystemTime,0,ADDR _stDTEnd,ADDR _stOut
cmp     eax,0
je      SubGetLastError
invoke  SystemTimeToFileTime,ADDR _stOut,ADDR ftEnd
cmp     eax,0
je      SubGetLastError
ret

; -------------------------------------------------------------------------
SubEnableControls:
invoke  EnableWindow,hWndBUSource,1
invoke  EnableWindow,hWndBUDisplay,1
invoke  EnableWindow,hWndBUFormat,1
invoke  EnableWindow,hWndBUCompression,1
invoke  EnableWindow,hWndBUPreview,1
invoke  EnableWindow,hWndBUStartCapture,1
invoke  EnableWindow,hWndBUStopCapture,1
invoke  EnableWindow,hWndBUFrameCapture,1
invoke  EnableWindow,hWndBUAutoCapture,1
invoke  EnableWindow,hWndBUAutoCaptureFrame,1
invoke  EnableWindow,hWndBUAutoCaptureVideo,1
invoke  EnableWindow,hWndCBCaptureDriver,1
ret

; -------------------------------------------------------------------------
SubDisableControls:
invoke  EnableWindow,hWndBUSource,0
invoke  EnableWindow,hWndBUDisplay,0
invoke  EnableWindow,hWndBUFormat,0
invoke  EnableWindow,hWndBUCompression,0
invoke  EnableWindow,hWndBUPreview,0
invoke  EnableWindow,hWndBUStartCapture,0
invoke  EnableWindow,hWndBUStopCapture,0
invoke  EnableWindow,hWndBUFrameCapture,0
invoke  EnableWindow,hWndBUAutoCaptureFrame,0
invoke  EnableWindow,hWndBUAutoCaptureVideo,0
invoke  EnableWindow,hWndDTStart,0
invoke  EnableWindow,hWndDTEnd,0
invoke  EnableWindow,hWndEDInterval,0
invoke  EnableWindow,hWndUDInterval,0
ret

; -------------------------------------------------------------------------
SubDisableControls1:
invoke  EnableWindow,hWndBUSource,0
invoke  EnableWindow,hWndBUDisplay,0
invoke  EnableWindow,hWndBUFormat,0
invoke  EnableWindow,hWndBUCompression,0
invoke  EnableWindow,hWndBUPreview,0
invoke  EnableWindow,hWndBUStartCapture,0
invoke  EnableWindow,hWndBUAutoCapture,0
invoke  EnableWindow,hWndBUFrameCapture,0
ret

; -------------------------------------------------------------------------
SubFrameCaptureSetControls:
invoke  EnableWindow,hWndCBCaptureDriver,1
invoke  EnableWindow,hWndDTStart,1
invoke  EnableWindow,hWndDTEnd,1
invoke  EnableWindow,hWndEDInterval,1
invoke  EnableWindow,hWndUDInterval,1
ret

; -------------------------------------------------------------------------
SubAviCaptureSetControls:
invoke  EnableMenuItem,hSysMenu,1050,MF_ENABLED
invoke  EnableWindow,hWndCBCaptureDriver,1
invoke  EnableWindow,hWndDTStart,1
invoke  EnableWindow,hWndDTEnd,1
invoke  EnableWindow,hWndEDInterval,0
invoke  EnableWindow,hWndUDInterval,0
ret

; -------------------------------------------------------------------------
SubAutoCaptureOFFSetControls:
call    SubEnableControls
invoke  EnableMenuItem,hSysMenu,1050,MF_ENABLED
cmp     flag_AutoCaptureMode,0
je      SubAutoCaptureOFFSetControlsFrame
cmp     flag_AutoCaptureMode,1
je      SubAutoCaptureOFFSetControlsAvi
ret
SubAutoCaptureOFFSetControlsFrame:
call    SubFrameCaptureSetControls
ret
SubAutoCaptureOFFSetControlsAvi:
call    SubAviCaptureSetControls
ret

; -------------------------------------------------------------------------
SubCleanSystem:
invoke  timeKillEvent,IdTimer
call    SubCapDriverDisconnect
invoke  Shell_NotifyIcon,NIM_DELETE,ADDR nid
invoke  DestroyWindow,hWndCaptureWindow
invoke  DestroyWindow,hWndCBCaptureDriver
invoke  DestroyWindow,hWndSB
invoke  DestroyWindow,hWndTT
invoke  DestroyWindow,hWndSTLogo
invoke  DestroyWindow,hWndBUSource
invoke  DestroyWindow,hWndBUDisplay
invoke  DestroyWindow,hWndBUFormat
invoke  DestroyWindow,hWndBUCompression
invoke  DestroyWindow,hWndBUPreview
invoke  DestroyWindow,hWndBUStartCapture
invoke  DestroyWindow,hWndBUStopCapture
invoke  DestroyWindow,hWndBUFrameCapture
invoke  DestroyWindow,hWndBUAutoCapture
invoke  DestroyWindow,hWndBUAutoCaptureFrame
invoke  DestroyWindow,hWndBUAutoCaptureVideo
invoke  DestroyWindow,hWndDTStart
invoke  DestroyWindow,hWndDTEnd
invoke  DestroyWindow,hWndEDInterval
invoke  DestroyWindow,hWndUDInterval
ret

; -------------------------------------------------------------------------
SubCreateSysMenu:
invoke  GetSystemMenu,WP_hWnd,0
mov     hSysMenu,eax
invoke  AppendMenu,hSysMenu,MF_SEPARATOR,0,0
invoke  AppendMenu,hSysMenu,MF_STRING,1050,ADDR szTargetFolder
invoke  AppendMenu,hSysMenu,MF_SEPARATOR,0,0
invoke  AppendMenu,hSysMenu,MF_STRING,1051,ADDR szAudioProperties
invoke  AppendMenu,hSysMenu,MF_SEPARATOR,0,0
invoke  AppendMenu,hSysMenu,MF_STRING,1052,ADDR szComaHome
invoke  AppendMenu,hSysMenu,MF_SEPARATOR,0,0
invoke  AppendMenu,hSysMenu,MF_STRING,1053,ADDR szAbout
ret

;--------------------------------------------------------------------------
SubHexDDtoStringDec:        ;EAX=Hex, EDI=pBuffer, Made by tE! // TMG
;--------------------------------------------------------------------------
push    0h                  ;get additional space on stack (10 bytes min.)
push    0h                  ;'' upper dword is 0
push    eax                 ;'' lower dword -> 32 bit integer to convert
fild    qword ptr[esp]      ;load 64 bit integer value on TOS
fbstp   real10 ptr[esp]     ; store value as 80bit BCD value
pop     ecx
pop     eax
mov     edx,ecx
mov     ebx,eax
shr     ecx,4
shr     eax,4
and     ebx,0000000Fh       ;mask nibbles
and     edx,0F0F0F0Fh       ;...
and     ecx,0F0F0F0Fh
add     edx,30303030h       ;build ascii numbers
add     ecx,30303030h       ;...
add     eax,30h
add     ebx,30h
mov     [edi],al            ;store in buffer
mov     [edi+1],bl          ;...
mov     [edi+8],cl
mov     [edi+9],dl
mov     [edi+6],ch
mov     [edi+7],dh
bswap   ecx                 ;endian conversion (486 processor needed)
bswap   edx                 ;dto.
mov     [edi+2],cl
mov     [edi+3],dl
mov     [edi+4],ch
mov     [edi+5],dh
pop     eax                 ;correct stack
ret

; -------------------------------------------------------------------------
SubGetLastError:
;--------------------------------------------------------------------------
invoke  GetLastError
invoke  FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,0,eax,0,ADDR BufferError,MAX_PATH,0
invoke  SendMessage,hWndSB,SB_SETTEXT,0,ADDR BufferError
ret

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
end Main
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

